;; Problem 56
;; 07 November 2003

;; A googol (10^100) is a massive number: one followed by one-hundred
;; zeros; 100^100 is almost unimaginably large: one followed by
;; two-hundred zeros. Despite their size, the sum of the digits in
;; each number is only 1.

;; Considering natural numbers of the form, ab, where a, b 100, what
;; is the maximum digital sum?

; (require 'asdf-install)
; (asdf-install:install 'cl-utilities)

(require 'cl-utilities)

(loop for ch across "123"
      do
      (format t "ch:~a~&" ch))

(defun explode-number (num)
  (loop for ch across (format nil "~d" num)
	collect (read-from-string (format nil "~a" ch))))

;; (explode-number 123)

(defun dig-sum (num)
  (apply #'+ (explode-number num)))

;; (dig-sum 123)

(defun find-max ()
    (let ((max 0)
	  (last-aa 0)
	  (last-bb 0))
      (loop for aa from 1 to 100
	    do
	    (loop for bb from 1 to 100
		  for sum = (dig-sum (expt aa bb))
		  do
		  (when (> sum max)
		    (setf max sum)
		    (setf last-aa aa)
		    (setf last-bb bb)
		    (format t "new val: ~a^~a = ~a~&"
			    aa bb
			    (dig-sum (expt aa bb))))))
      (format t "found max: aa:~a bb:~a dig-sum:~a~&"
	      last-aa
	      last-bb
	      max)))

(time (find-max))